#!/bin/sh
###########################################################################
#
# Easy Install (C) Copyright 1994,1995 Hubert Feyrer
#
#--------------------------------------------------------------------------
#
# This software may not be used in non-academic environment without the
# author's written permission.
#
#--------------------------------------------------------------------------
#
# V1.0 940904 Initial hacking
# V1.1 940921 Change /opt to /usr/local
# V1.2 940925 Fix bug when linking directories
# V1.3 950107 Add support for directories man/mann and man/catn
# V1.4 951126 Add support for directories man/manl and man/catl
#      960108 Add support for man9/cat9
#      960406 Incorporate changes for SysV/BSD-echo and -test
#      960518 Implement {pre/post}uninstall
#
#--------------------------------------------------------------------------
# ============== Hubert Feyrer =========================================== 
#      Weekdays: Rennerstr. 19, D-93053 Regensburg,  Tel. 0941/943-2905
#      Weekends: Bachstr. 40,   D-84066 Mallersdorf, Tel. 08772/6084
#      Internet: hubert.feyrer@rz.uni-regensburg.de == IRC: hubertf
# ======================================================================== 
###########################################################################

# Verbosity control
exec=""		# set to "echo" to display commands 
v1=true		# Introduction blurb
v2=true		# what's going on
v3=false	# debugging stuff
v4=true		# do "$exec command" ? (more debugging)

# Does your echo understand -n (BSD) or do you use echo "\c" (SysV)?
echostyle=BSD
#echostyle=SysV

###########################################################################
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# No changes should be made below this line !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
###########################################################################

# Defaults
BASE=/usr/local
BIN=""
ETC=""
LIB=""
MAN1=""
MAN2=""
MAN3=""
MAN4=""
MAN5=""
MAN6=""
MAN7=""
MAN8=""
MAN9=""
MANN=""
MANL=""
CAT1=""
CAT2=""
CAT3=""
CAT4=""
CAT5=""
CAT6=""
CAT7=""
CAT8=""
CAT9=""
CATN=""
CATL=""
INFO=""
APPDEF=""
INCLUDE=""
SUIDROOT=""
MISCDIRS=""


#
# Get echo-style
#
if [ "$echostyle" = "BSD" ]; then
	nobr1="-n"
	nobr2=""
else
	nobr1=""
	nobr2="\c"
fi


#
# Read package-information
#
$v3&&echo using configuration from `dirname $0`/package
. `dirname $0`/package


$v1&& echo Removing $PKG from $BASE

#
# run preuninstall, if available
#
doit=`dirname $0`/preuninstall
if [ -f $doit ]; then
	$v2&&echo Running preuninstall script
	if [ -x $doit ]; then
		$v4&&$exec $doit
	else
		$v4&&$exec sh doit
	fi
fi

#
# Determine directory where application defaults for X go to
#
if [ "$APPDEF" != "" ];
then
	# search some directories
	for d in /usr /usr/local/X11R6 /usr/X11R6 /usr/local/X11R5 /usr/X11R5 \
		 $BASE/X11R6 $BASE/X11R5;
	do
        	if [ -d  $d/lib/X11/app-defaults ];
        	then
			APPDEFDIR=$d/lib/X11/app-defaults
                	break
        	fi
	done
	# nothing found, ask user
	while [ "$APPDEFDIR" = "" -o ! -d "$APPDEFDIR" ];
	do
		echo Couldn\'t figure out directory for X application-defaults.
		echo $nobr1 "Please specify: " $nobr2
		read APPDEFDIR
	done
        $v3&&echo APPDEFDIR: $APPDEFDIR
fi

#
# Link existing files from package to destination
#
doremove()
{
	what=$1 ; shift
	dir=$1  ; shift

	if [ "$*" != "" ];
	then
		$v2&&echo $nobr1 removing $what: $nobr2
		for i in $* ;
		do
			file=$BASE/$dir/$i
			if [ -r "$file" ];
			then
				$v2&&echo $nobr1 " $i" $nobr2
				$v4&&$exec rm -f $file
			else
				echo ''
				echo ERROR: $file not found!
			fi
		done
		$v2&&echo .

		# rmdir if necessary
		$v4&&$exec rmdir -p $BASE/$dir 2>/dev/null
	fi
}

doremove "binaries"					bin		$BIN
doremove "etc-files"					etc		$ETC
doremove "libraries"					lib		$LIB
doremove "unformatted man-pages for general commands"	man/man1	$MAN1
doremove "unformatted man-pages for system calls"	man/man2	$MAN2
doremove "unformatted man-pages for C libraries"	man/man3	$MAN3
doremove "unformatted man-pages for device driver"	man/man4	$MAN4
doremove "unformatted man-pages for file formats"	man/man5	$MAN5
doremove "unformatted man-pages for games"		man/man6	$MAN6
doremove "unformatted man-pages for miscellaneous"	man/man7	$MAN7
doremove "unformatted man-pages for system operation"	man/man8	$MAN8
doremove "unformatted man-pages for kernel internals"   man/man9        $MAN9
doremove "unformatted man-pages for new software"	man/mann	$MANN
doremove "unformatted man-pages for local programs"	man/manl	$MANL
doremove "formatted man-pages for general commands"	man/cat1	$CAT1
doremove "formatted man-pages for system calls"		man/cat2	$CAT2
doremove "formatted man-pages for C libraries"		man/cat3	$CAT3
doremove "formatted man-pages for device driver"	man/cat4	$CAT4
doremove "formatted man-pages for file formats"		man/cat5	$CAT5
doremove "formatted man-pages for games"		man/cat6	$CAT6
doremove "formatted man-pages for miscellaneous"	man/cat7	$CAT7
doremove "formatted man-pages for system operation"	man/cat8	$CAT8
doremove "formatted man-pages for kernel internals"     man/cat9        $CAT9
doremove "formatted man-pages for new software"		man/catn	$CATN
doremove "formatted man-pages for local stuff"		man/catl	$CATL
doremove "info-manual"					info		$INFO
doremove "includes"					include		$INCLUDE

#
# application defaults for X
#
if [ "$APPDEF" != "" ];
then
        $v2&&echo $nobr1 removing X application defaults: $nobr2
        for i in $APPDEF ;
        do
		file=`basename $i .ad`
                if [ -r "$APPDEFDIR/$file" ];
                then
                        $v2&&echo $nobr1 " $file" $nobr2
                        $v4&&$exec rm -f $APPDEFDIR/$file
                else
			echo ''
                        echo ERROR: $APPDEFDIR/$file not found!
                fi
        done
        $v2&&echo .
fi


#
# Create misc directories, if necessary
#
for i in $MISCDIRS ;
do
	rmdir -p $BASE/$i 2>/dev/null
done

#
# run postuninstall, if available
#
doit=`dirname $0`/postuninstall
if [ -f $doit ]; then
	$v2&&echo Running postuninstall script
	if [ -x $doit ]; then
		$v4&&$exec $doit
	else
		$v4&&$exec sh $doit
	fi
fi


$v1&&echo Done.
